;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-lambda-reader.ss" "lang")((modname find) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f () #f)))
;; A file is either:
;;   a rawFile, or
;;   a dir (short for directory)

;; A rawFile is (make-rawFile text) where text is a
;; a char-list
(define-struct rawFile (text))

;; A dir is a structure
;; (make-dir nFiles) where nFiles is a nFile-list
(define-struct dir (nFiles))

;; An nFile is a structure
;; (make-nFile name f) where name is a symbol and f is
;; a file.
(define-struct nFile (name file))

;; Examples
(define rf (make-rawFile '(#\a #\  #\r #\a #\w #\  #\f \#i \#l \#e)))
(define d1 (make-dir (list (make-nFile 'corky rf) (make-nFile 'agnishom rf))))
(define d2 (make-dir (list (make-nFile 'hung rf) (make-nFile 'krishna rf))))
(define bigd (make-dir (list (make-nFile 'comp311 d1) (make-nFile 'comp582 d2) (make-nFile 'junkFile rf))))

; file-f : f -> ...
#|
(define (file-f ... f ...)
  (cond [(rawFile? f) ...]
        [(dir? f) ... 
         ... (dir-f ... f ...)) ... ]))
|#

; dir-f : dir -> ...
#|
(define (dir-f ... d ...)
   ... (nFiles-f ... (dir-nFiles d) ...) ... )
|#

; nFiles-f: nFile-list -> ...
#|
(define (nFiles-f ... nFiles ... ) ;; nFiles is nFile-list
  (cond [(empty? nFiles) ... ]
        [(cons? nFiles) ...
         ... (file-f ... (nFile-file (first nFiles)) ... ) ... )
         ... (nFiles-f... (rest nFiles) ...) ... ]
|#

; find?: file symbol -> boolean
; Purpose: (find? f n) determines whether the file f is a directory and if so, whether it contains a file named n;
; it returns false if f is a rawfile.
;; Examples
(check-expect (find? rf 'corky) false)
(check-expect (find? bigd 'corky) true)
(check-expect (find? bigd 'luay) false)
(check-expect (find? bigd 'junkFile) true)
(check-expect (find? bigd 'krishna) true)

; Instantiated template
#|
(define (find? f n) 
  (cond [(rawFile? f) false]
        [(dir? f) ... (nFiles-find? (dir-nFiles f) n) ... )

(define (nFiles-find? nfl n)
  (cond [(empty? nfl) ...]
        [(cons? nfl) 
         ... (nFile-find? (first nfl) n) ...
         ... (nFiles-find? (rest nfl) n) ... ]))

(define (nFile-find? nf n)
  ... (nFile-name nf) ... 
  ... (find? (nFile-file nf) n) ... )
|#

;; Code

(define (find? f n) 
  (cond [(rawFile? f) false]
        [(dir? f) (nFiles-find? (dir-nFiles f) n)]))

(define (nFiles-find? nfl n)
  (cond [(empty? nfl) false]
        [(cons? nfl) 
         (or (nFile-find? (first nfl) n)
             (nFiles-find? (rest nfl) n))]))

(define (nFile-find? nf n)
  (or (equal? (nFile-name nf) n) 
      (find? (nFile-file nf) n)))